Object subclass: #Deck
	instanceVariableNames: 'cardnames undealt dealt'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PlayingCards'!

!Deck methodsFor: 'as yet unclassified' stamp: 'MT 8/25/2008 11:37'!
cardName: i
^cardnames at: i! !

!Deck methodsFor: 'as yet unclassified' stamp: 'MT 8/25/2008 11:34'!
deal
	| i newCard |
	i := undealt pop.
	newCard := PlayingCard at: i from: self.
	dealt add: i.
	^ newCard! !

!Deck methodsFor: 'as yet unclassified' stamp: 'MT 8/25/2008 11:32'!
initialize
| index addCard|
	cardnames := Array new: 52.
	index := 0.
	addCard := [:c :s | index := index + 1.
					cardnames
						at: index
						put: ('<1s> of <2s>' expandMacrosWithArguments: {(c asString) . s})].
	{'Diamonds'. 'Spades'. 'Hearts'. 'Clubs'}
		do: [:suit | 
			addCard value: 'Ace' value: suit.
			2 to: 10
				do: [:i | addCard value: i value: suit].
			{'Knave'. 'Queen'. 'King'}
				do: [:c | 
					addCard value: c value: suit]].
	undealt := Stack new.
	(1 to: cardnames size) reverseDo: [:i | undealt push: i ].
	dealt := OrderedCollection new: cardnames size.! !

!Deck methodsFor: 'as yet unclassified' stamp: 'MT 8/25/2008 11:29'!
shuffle
 | newUndealt |
newUndealt := Stack new.
 (OrderedCollection newFrom: undealt linkedList) shuffled do: [:l | newUndealt push: l element].
 undealt := newUndealt.! !


Object subclass: #PlayingCard
	instanceVariableNames: 'index deck'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PlayingCards'!

!PlayingCard methodsFor: 'accessing' stamp: 'MT 8/25/2008 11:02'!
deck
	^ deck! !

!PlayingCard methodsFor: 'accessing' stamp: 'MT 8/25/2008 11:02'!
deck: anObject
	deck := anObject! !

!PlayingCard methodsFor: 'accessing' stamp: 'MT 8/25/2008 11:02'!
index
	^ index! !

!PlayingCard methodsFor: 'accessing' stamp: 'MT 8/25/2008 11:02'!
index: anObject
	index := anObject! !


!PlayingCard methodsFor: 'as yet unclassified' stamp: 'MT 8/25/2008 11:37'!
asString
 ^deck cardName: index! !

!PlayingCard methodsFor: 'as yet unclassified' stamp: 'MT 8/25/2008 11:53'!
printString
 ^self asString! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

PlayingCard class
	instanceVariableNames: ''!

!PlayingCard class methodsFor: 'as yet unclassified' stamp: 'MT 8/25/2008 11:02'!
at: index from: deck 
	^ self new index: index;
		 deck: deck! !
